diff -bwcr wais-8-b5/ir/ircfiles.c w8b5bio/ir/ircfiles.c
*** wais-8-b5/ir/ircfiles.c	Wed May  6 19:27:43 1992
--- w8b5bio/ir/ircfiles.c	Sun Nov  8 19:09:51 1992
***************
*** 117,122 ****
--- 121,1328 ----
    return(string);
  }
  
+ 
+ #ifdef BIO
+ 
+ char bio_header1[MAX_HEADER_LEN + 1];
+ char bio_header2[MAX_HEADER_LEN + 1];
+ 
+ 
+ /* ==========================================
+  *
+  * ===  Genbank Flat-file Customizations  ===
+  *
+  * d.g.gilbert, 15feb92, 
+  * gilbertd@bio.indiana.edu
+  *
+  * ==========================================
+  */
+ 
+ #define genbank_data_tab	12
+ #define genbank_date_tab	63
+ 
+ /* Genbank Flat-file format:
+ LOCUS       ACAAC01      1571 bp ds-DNA             INV       05-NOV-1991 << start entry
+ 12345678901234567890123456789012345678901234567890123456789012345678901234567890
+ .........1.........2.........3.........4.........5.........6.........7.........8
+ all data starts at tab=13
+ on locus line, data starts at tab=63
+ ...
+ LOCUS       blah	<< Start entry, index LOCUS_NAME, includes DATE
+ DEFINITION  blah   	<< Index def line == HEADER line
+ ACCESSION   blah	<< Index acc line
+ KEYWORDS    blah	<< index keywords
+ SOURCE      blah	<< index source
+   ORGANISM  blah	<< index organism
+             blah	<< index taxonomy
+ 			blah	<< "
+   AUTHORS   blah	<< Index
+   TITLE     blah	<< Index
+             blah	<< Index
+ ANYOTHERS	jazz	<< skipit
+ //  				<< end of entry == entry separator
+ LOCUS       ACAAC01      1571 bp ds-DNA             INV       05-NOV-1991 << start entry
+ DEFINITION  Acanthamoeba castelani gene encoding actin I.
+ ACCESSION   V00002 J01016
+ KEYWORDS    actin.
+ SOURCE      Acanthamoeba castellanii DNA.
+   ORGANISM  Acanthamoeba castellanii
+             Eukaryota; Animalia; Protozoa; Sarcomastigophora; Sarcodina;
+             Rhizopoda; Lobosa; Gymnamoeba; Amoebida; Acanthopodina;
+             Acanthamoebidae.
+ REFERENCE   1  (bases 1 to 1571)
+   AUTHORS   Nellen,W. and Gallwitz,D.
+   TITLE     Actin genes and actin messenger RNA in Acanthamoeba castellani.
+             Nucleotide sequence of the split actin gene I
+   JOURNAL   J. Mol. Biol. 159, 1-18 (1982)
+ COMMENT     SWISS-PROT; P02578; ACT1$ACACA.
+                From EMBL 26   entry ACAC01;  dated 22-JAN-1991.
+ 
+ FEATURES             Location/Qualifiers
+ 	>>> ignore all features
+ 	
+ BASE COUNT      313 a    535 c    389 g    334 t
+ ORIGIN
+         1 ggagaagcgt gcacgcaata accaagcgac agagcaacct ctctggcacc acgccccaca
+ 	>>> ignore all seq data in indexing
+ //  <<< end of entry
+ LOCUS       ACAMHCA      5894 bp ds-DNA             INV       30-SEP-1988
+ ...
+ *****/
+ 
+ 
+ static  boolean  keepindexing = false;
+ 
+ void genbank_filter_for_index(line)
+ char* line;
+ {
+   /* check whether to index anything in line, 
+    * call this from genbank_header_function which is called for
+    * each line.  
+    * Blank out parts of line not for indexing...
+    */
+   char *c;
+   long  i;
+   
+   if (strlen(line) <= genbank_data_tab) {
+ 	 for (c=line ; *c>=' '; c++) *c=' ';
+ 	 keepindexing= false;  
+   	 }
+ 	 
+   else if (substrcmp(line, "            ")) {  
+ 		/* most lines are like this, including nucleotides */
+   	 if (!keepindexing) for (c=line ; *c>=' '; c++) *c=' ';
+      }
+ 	 
+   /*******
+    else if (substrcmp(line, "LOCUS       ")){
+     	// I think this is bad, locus not in index ... 
+ 	 for (c=line, i=0; *c>=' ' && i<genbank_data_tab; i++, c++) *c=' ';
+ 	 for ( ; *c>' '; c++) ;  // leave LOCUS ID intact  
+ 	 for ( ; *c>=' '; c++) *c=' '; 
+ 	 keepindexing= false;
+      }
+ 	******/ 
+ 	
+   else if ( 
+    	   substrcmp(line, "DEFINITION  ") 
+   	|| substrcmp(line, "LOCUS       ")
+   	|| substrcmp(line, "ACCESSION   ")
+   	|| substrcmp(line, "KEYWORDS    ")
+   	|| substrcmp(line, "SOURCE      ")
+   	|| substrcmp(line, "  ORGANISM  ")
+   	|| substrcmp(line, "  AUTHORS   ")
+   	|| substrcmp(line, "  TITLE     ")
+ 	){
+ 	 for (c=line, i=0; *c>=' ' && i<genbank_data_tab; i++, c++) *c=' ';
+ 	 keepindexing= true;
+      }
+ 
+   else {
+ 	 for (c=line ; *c>=' '; c++) *c=' ';
+ 	 keepindexing= false;
+      }
+ }
+ 
+ 
+ 
+ boolean genbank_separator_function(line)
+ char *line;
+ {
+ /* !! with // as separator, we get // at top of entry which will
+    screw up seqanal software... */
+ /*  if ((strlen(line) > 1) && (0==strncmp(line, "//", 2))){
+      return(true);
+      }  
+ */
+   if ((strlen(line) > genbank_data_tab) && substrcmp(line, "LOCUS       ")){
+      return(true);
+      }
+   else{
+     return(false);
+     }
+ }
+ 
+ long genbank_getdate(line)
+ char *line;
+ {
+ 	/* genbank date == 30-SEP-1988*/
+   char date[255], *temp;
+   int day, month, year;
+   char cmonth[25];
+ 
+   strcpy(date, line);
+ 
+   temp = date;
+ 
+   while(!isdigit(*temp)) temp++;
+ 
+   /* sscanf(temp, "%d %s %d", &day, cmonth, &year); */
+   sscanf(temp, "%d-%s-%d", &day, cmonth, &year);
+ 
+   for(month = 0; months[month] != NULL; month++)
+     /* if(!strcmp(cmonth, months[month])) break; */
+     if(!strcasecmp(cmonth, months[month])) break; /* was stricmp !! */
+ 
+   if (year > 99) year = year % 100;
+ 
+   if(day > 0 && 
+      month < 12 &&
+      year > 0) {
+     return (10000 * year + 100 * (month+1) + day);
+   }
+   return 0;
+ }
+ 
+ long genbank_date_function(line)
+ char *line;
+ {
+   if ((strlen(line) > genbank_data_tab) && substrcmp(line, "LOCUS       ")){
+     return(genbank_getdate(line+genbank_date_tab));
+   }
+   else 
+     return -1;
+ }
+ 
+   
+ 
+ char *genbank_def = bio_header1;
+ char *genbank_accession= bio_header2;
+ 
+ void genbank_header_function(line)
+ char *line;
+ {
+   if ((strlen(line) > genbank_data_tab) && substrcmp(line, "DEFINITION  ") &&
+      (strlen(genbank_def) == 0)){
+     strncpy(genbank_def, line + genbank_data_tab, MAX_HEADER_LEN);
+     trim_trailing_newline(genbank_def);
+     }
+ 	
+   else if ((strlen(line) > genbank_data_tab) &&
+      substrcmp(line, "ACCESSION   ") &&
+      (strlen(genbank_accession) == 0)){
+ 	/* cut extra acc. numbers from this -- we want only 1st */
+ 	char *cp;
+ 	for (cp=line+genbank_data_tab; *cp==' '; cp++) ;
+     strncpy(genbank_accession, cp, MAX_HEADER_LEN);
+ 	cp= strchr(genbank_accession, ' ');
+ 	if (cp!=NULL) *cp=0; /* drop after 1st */
+     trim_trailing_newline(genbank_accession);
+     }
+   
+   genbank_filter_for_index( line);
+   
+ }
+ 
+ void genbank_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(genbank_def) != 0 && strlen(genbank_accession) != 0){
+     strncpy(header, genbank_accession, MAX_HEADER_LEN);
+     s_strncat(header, " ", MAX_HEADER_LEN, MAX_HEADER_LEN);
+     s_strncat(header, genbank_def, MAX_HEADER_LEN, MAX_HEADER_LEN);
+   }
+   else if(strlen(genbank_def) != 0){
+     strncpy(header, genbank_def, MAX_HEADER_LEN);
+   }
+   else if(strlen(genbank_accession) != 0){
+     strncpy(header, genbank_accession, MAX_HEADER_LEN);
+   }
+   else{
+     strcpy(header, "Unknown Entry");
+   }
+   genbank_def[0] = '\0';
+   genbank_accession[0] = '\0';
+ }
+ 
+ 
+ /* ==========================================
+  *
+  * ===  PIR Protein Customizations  ===
+  *
+  * d.g.gilbert, 11Mar92, 
+  * gilbertd@bio.indiana.edu
+  *
+  * ==========================================
+  */
+ 
+ #define pir_data_tab	16
+ 
+ /* pir Flat-file format:
+ ENTRY           CCHU       #Type Protein
+ 12345678901234567890123456789012345678901234567890123456789012345678901234567890
+ .........1.........2.........3.........4.........5.........6.........7.........8
+ all data starts at tab=17 or further
+ 
+ ENTRY       blah	<< Start entry, index it
+ TITLE	    blah   	<< Index def line == HEADER line
+ ACCESSION   blah	<< Index acc line
+ KEYWORDS    blah	<< index keywords
+ SOURCE      blah	<< index source
+ REFERENCE   blah	<< Index
+ SUPERFAMILY blah	<< Index
+             blah	<< Index
+ ANYOTHERS	jazz	<< skipit
+ any word starting w/ "#", skipit
+ ///  				<< end of entry == entry separator
+ ENTRY           CCHU       #Type Protein
+ TITLE           Cytochrome c - Human
+ DATE            #Sequence 30-Sep-1991 #Text 30-Sep-1991
+ PLACEMENT          1.0    1.0    1.0    1.0    1.0
+ SOURCE          Homo sapiens #Common-name man
+ ACCESSION       A31764\ A05676\ A00001
+ REFERENCE
+    #Authors     Evans M.J., Scarpulla R.C.
+    #Journal     Proc. Natl. Acad. Sci. U.S.A. (1988) 85:9625-9629
+    #Title       The human somatic cytochrome c gene: two classes of
+                   processed pseudogenes demarcate a period of rapid
+                   molecular evolution.
+    #Reference-number A31764
+    #Accession   A31764
+    #Molecule-type DNA
+    #Residues    1-105 <EVA>
+    #Cross-reference GB:M22877
+ REFERENCE
+    #Authors     Matsubara H., Smith E.L.
+    #Journal     J. Biol. Chem. (1963) 238:2732-2753
+    #Reference-number A05676
+    #Accession   A05676
+    #Molecule-type protein
+    #Residues    2-28;29-46;47-100;101-105 <MATS>
+ REFERENCE
+    #Authors     Matsubara H., Smith E.L.
+    #Journal     J. Biol. Chem. (1962) 237:3575-3576
+    #Reference-number A00001
+    #Comment     66-Leu is found in 10% of the molecules in pooled
+                   protein.
+ GENETIC
+    #Introns        57/1
+ SUPERFAMILY     #Name cytochrome c
+ KEYWORDS        acetylation\ electron transport\ heme\
+                   mitochondrion\ oxidative phosphorylation\
+                   polymorphism\ respiratory chain
+ FEATURE
+    2-105                   #Protein cytochrome c (experimental)
+                              <MAT>\
+    2                       #Modified-site acetylated amino end
+                              (experimental)\
+    15,18                   #Binding-site heme (covalent)\
+    19,81                   #Binding-site heme iron (axial ligands)
+ SUMMARY       #Molecular-weight 11749  #Length 105  #Checksum  3247
+ SEQUENCE
+                 5        10        15        20        25        30
+       1 M G D V E K G K K I F I M K C S Q C H T V E K G G K H K T G
+      31 P N L H G L F G R K T G Q A P G Y S Y T A A N K N K G I I W
+      61 G E D T L M E Y L E N P K K Y I P G T K M I F V G I K K K E
+      91 E R A D L I A Y L K K A T N E
+ ///
+ 
+ *****/
+ 
+ 
+ void pir_filter_for_index(line)
+ char* line;
+ {
+   /* check whether to index anything in line, 
+    * call this from pir_header_function which is called for
+    * each line.  
+    * Blank out parts of line not for indexing...
+    */
+   char *c;
+   long  i;
+   
+   if (strlen(line) <= pir_data_tab) {
+ 	 for (c=line ; *c>=' '; c++) *c=' ';
+ 	 keepindexing= false;  
+   	 }
+  
+ /* drop some ref junk that is not of much indexing interest... */
+   else if (substrcmp(line, "   #Reference-number ") 
+   	|| substrcmp(line, "   #Residues ")
+   	|| substrcmp(line, "   #Accession ")
+    	|| substrcmp(line, "   #Residues ")
+     	|| substrcmp(line, "   #Cross-reference ")
+    	|| substrcmp(line, "   #Molecule-type ")
+    	|| substrcmp(line, "   #Journal ") ) {   
+ 	 for (c=line ; *c>=' '; c++) *c=' ';
+ 	 /* keepindexing is based on last main keyword (ENTRY, REF...) */
+   	 }
+ 
+   else if (substrcmp(line, "   ")) {  
+ 	/* some good & bad continuation lines start like this */
+   	 if (!keepindexing) for (c=line ; *c>=' '; c++) *c=' ';
+      }
+ 	 	
+   else if ( 
+    	   substrcmp(line, "ENTRY           ") 
+   	|| substrcmp(line, "TITLE           ")
+   	|| substrcmp(line, "SOURCE          ")
+   	|| substrcmp(line, "ACCESSION       ")
+   	|| substrcmp(line, "REFERENCE")  
+ /* REFERENCE line seems to have no data on line, but it follows (keepindexing) */
+   	|| substrcmp(line, "SUPERFAMILY     ")
+   	|| substrcmp(line, "KEYWORDS        ")
+ 	){
+ 	 for (c=line, i=0; *c>=' ' && i<pir_data_tab; i++, c++) *c=' ';
+ 	 keepindexing= true;
+      }
+ 
+   else {
+ 	 for (c=line ; *c>=' '; c++) *c=' ';
+ 	 keepindexing= false;
+      }
+   
+   /* pir -- blank out #words */
+   for (c=line; *c != 0; ) {
+     if (*c=='#') do { *c++=' '; } while (*c > ' ');
+     else c++;    
+     }
+ 
+ }
+ 
+ 
+ 
+ boolean pir_separator_function(line)
+ char *line;
+ {
+ /* !! with /// as separator, we get /// at top of entry which will
+    screw up seqanal software... */
+ /*  if ((strlen(line) > 1) && (0==strncmp(line, "///", 2))){
+      return(true);
+      }  
+ */
+   if ((strlen(line) > pir_data_tab) && substrcmp(line, "ENTRY           ")){
+      return(true);
+      }
+   else{
+     return(false);
+     }
+ }
+ 
+ 
+ long pir_date_function(line)
+ char *line;
+ { /* later maybe */
+     return -1;
+ }
+ 
+   
+ 
+ char *pir_def = bio_header1;
+ char *pir_accession= bio_header2;
+ 
+ void pir_header_function(line)
+ char *line;
+ {
+   if ((strlen(line) > pir_data_tab) &&
+      substrcmp(line, "TITLE           ") &&
+      (strlen(pir_def) == 0)){
+     strncpy(pir_def, line + pir_data_tab, MAX_HEADER_LEN);
+     trim_trailing_newline(pir_def);
+     }
+ 	
+   else if ((strlen(line) > pir_data_tab) &&
+      substrcmp(line, "ACCESSION      ") &&
+      (strlen(pir_accession) == 0)){
+ 	/* cut extra acc. numbers from this -- we want only 1st */
+ 	char *cp;
+ 	for (cp=line+pir_data_tab; *cp==' '; cp++) ;
+             strncpy(pir_accession, cp, MAX_HEADER_LEN);
+ 	cp= strchr(pir_accession, ' ');
+ 	if (cp!=NULL) *cp=0; /* drop after 1st */
+         trim_trailing_newline(pir_accession);
+         }
+   
+   pir_filter_for_index( line);
+   
+ }
+ 
+ void pir_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(pir_def) != 0 && strlen(pir_accession) != 0){
+     strncpy(header, pir_accession, MAX_HEADER_LEN);
+     s_strncat(header, " ", MAX_HEADER_LEN, MAX_HEADER_LEN);
+     s_strncat(header, pir_def, MAX_HEADER_LEN, MAX_HEADER_LEN);
+   }
+   else if(strlen(pir_def) != 0){
+     strncpy(header, pir_def, MAX_HEADER_LEN);
+   }
+   else if(strlen(pir_accession) != 0){
+     strncpy(header, pir_accession, MAX_HEADER_LEN);
+   }
+   else{
+     strcpy(header, "Unknown Entry");
+   }
+   pir_def[0] = '\0';
+   pir_accession[0] = '\0';
+ }
+ 
+ 
+ 
+ /* ==========================================
+  * ===    EMBL Flat-file Customizations  ===
+  * d.g.gilbert, 23Feb92, 
+  * ==========================================
+  */
+ 
+ #define embl_data_tab	5
+ 
+ /* EMBL Flat-file format:
+ 
+ ID   BAAMYLA    standard; DNA; PRO; 7872 BP.
+ 1234567890
+ XX
+ AC   X62835;
+ XX
+ DT   12-NOV-1991 (Rel. 29, Last updated, Version 1)
+ DT   12-NOV-1991 (Rel. 29, Created)
+ XX
+ DE   B.acidocaldarius amy gene for amylase
+ XX
+ KW   amy gene; amylase.
+ XX
+ OS   Bacillus acidocaldarius
+ OC   Prokaryota; Bacteria; Firmicutes; Endospore-forming rods and cocci;
+ OC   Bacillaceae; Bacillus.
+ XX
+ RN   [1]
+ RP   1-7872
+ RA   Hemila H.O.;
+ RT   ;
+ RL   Submitted (22-OCT-1991) on tape to the EMBL Data Library by:
+ RL   H.O. Hemila, Institute of Biotechnology, Valimotie 7, 00380
+ RL   Helsinki, FINLAND
+ XX
+ RN   [2]
+ RP   1-7872
+ RA   Koivula T., Hemilae H.;
+ RT   ;
+ RL   Unpublished.
+ XX
+ CC   *source: strain=ATCC 27009;
+ CC   *source: clone_library=lambda gt-10;
+ XX
+ FH   Key             Location/Qualifiers
+ FH
+ FT   -35_signal      3224..3229
+ FT   -10_signal      3246..3251
+ FT   RBS             3288..3294
+ FT                   /note="amy gene"
+ FT   CDS             3297..7202
+ FT                   /gene="amy" /product="amylase"
+ FT   CDS             7332..>7872
+ FT                   /product="malE protein-homologue"
+ XX
+ SQ   Sequence 7872 BP; 1615 A; 2240 C; 2473 G; 1544 T; 0 other;
+      cgttcctcgt gccgtccgaa gcgttcccga cgaatctgcg cggcaccgcc gcgggatctc
+ //
+ *****/
+ 
+ 
+ 
+ void embl_filter_for_index(line)
+ char* line;
+ {
+   /* check whether to index anything in line, 
+    * call this from embl_header_function which is called for
+    * each line.  
+    * Blank out parts of line not for indexing...
+    */
+   char *c;
+   long  i;
+   
+   if (strlen(line) <= embl_data_tab) {
+ 	 for (c=line; *c>=' '; c++) *c=' ';
+   	 }
+ 	 
+   else if ( 
+    	   substrcmp(line, "DE   ") 
+   	|| substrcmp(line, "ID   ")
+   	|| substrcmp(line, "AC   ")
+   	|| substrcmp(line, "KW   ")
+   	|| substrcmp(line, "OS   ")
+   	|| substrcmp(line, "OC   ")
+   	|| substrcmp(line, "RA   ")
+   	|| substrcmp(line, "RT   ")
+ 	){
+ 	 for (c=line, i=0; *c>=' ' && i<embl_data_tab; i++, c++) *c=' ';
+      }
+ 
+   else {
+ 	 for (c=line ; *c>=' '; c++) *c=' ';
+      }
+ }
+ 
+ 
+ 
+ boolean embl_separator_function(line)
+ char *line;
+ {
+ /* !! with // as separator, we get // at top of entry which will
+    screw up seqanal software... */
+ /*  if ((strlen(line) > 1) && (0==strncmp(line, "//", 2))){
+      return(true);
+      }  
+ */
+   if ((strlen(line) > embl_data_tab) && substrcmp(line, "ID   ")){
+      return(true);
+      }
+   else{
+     return(false);
+     }
+ }
+ 
+ /* embl date == 30-SEP-1988 == genbank_date*/
+ 
+ long embl_date_function(line)
+ char *line;
+ {
+   if ((strlen(line) > embl_data_tab) && substrcmp(line, "DT   ")){
+     return(genbank_getdate(line+embl_data_tab));
+   }
+   else 
+     return -1;
+ }
+ 
+   
+ 
+ char *embl_def = bio_header1;
+ char *embl_accession= bio_header2;
+ 
+ void embl_header_function(line)
+ char *line;
+ {
+   if ((strlen(line) > embl_data_tab) &&
+      substrcmp(line, "DE   ") &&
+      (strlen(embl_def) == 0)){
+     strncpy(embl_def, line + embl_data_tab, MAX_HEADER_LEN);
+     trim_trailing_newline(embl_def);
+     }
+ 	
+   else if ((strlen(line) > embl_data_tab) &&
+      substrcmp(line, "AC   ") &&
+      (strlen(embl_accession) == 0)){
+ 	/* cut extra acc. numbers from this -- we want only 1st */
+ 	char *cp;
+ 	for (cp=line+embl_data_tab; *cp==' '; cp++) ;
+   	strncpy(embl_accession, cp, MAX_HEADER_LEN);
+ 	cp= strchr(embl_accession, ' ');
+ 	if (cp!=NULL) *cp=0; /* drop after 1st */
+     	trim_trailing_newline(embl_accession);
+     }
+   
+   embl_filter_for_index( line);
+   
+ }
+ 
+ void embl_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(embl_def) != 0 && strlen(embl_accession) != 0){
+     strncpy(header, embl_accession, MAX_HEADER_LEN);
+     s_strncat(header, " ", MAX_HEADER_LEN, MAX_HEADER_LEN);
+     s_strncat(header, embl_def, MAX_HEADER_LEN, MAX_HEADER_LEN);
+   }
+   else if(strlen(embl_def) != 0){
+     strncpy(header, embl_def, MAX_HEADER_LEN);
+   }
+   else if(strlen(embl_accession) != 0){
+     strncpy(header, embl_accession, MAX_HEADER_LEN);
+   }
+   else{
+     strcpy(header, "Unknown Entry");
+   }
+   embl_def[0] = '\0';
+   embl_accession[0] = '\0';
+ }
+ 
+ 
+ 
+ /* ==========================================
+  *
+  * ===  Prosite Dat & Doc Customizations  ===
+  *
+  * d.g.gilbert, 18feb92, 
+  * gilbertd@bio.indiana.edu
+  *
+  * ==========================================
+  */
+ 
+ #define prositedat_data_tab	5
+ 
+ /* Prosite DOC format:
+ 
+ {END}
+ {PDOC00002}
+ {PS00002; GLYCOSAMINOGLYCAN}
+ {BEGIN}
+ *************************************
+ * Glycosaminoglycan attachment site *
+ *************************************
+ 
+ Proteoglycans [1] are complex glycoconjugates consisting of a core  protein to
+ which a variable number of glycosaminoglycan chains  (such as heparin sulfate,
+ chondroitin sulfate, etc.) are covalently attached. The glycosaminoglycans are
+ attached to the core proteins through  a xyloside residue which is  in turn is
+ linked to  a serine   residue of the protein.    A consensus sequence for  the
+ attachment  site seems  to exist [2].   However,  it must be noted  that  this
+ consensus is only based on the sequence of three proteoglycans core proteins.
+ 
+ -Consensus pattern: S-G-x-G
+                     [S is the attachment site]
+  Additional rule: There must be at least  two acidic amino acids from -2 to -4
+                   relative to the serine.
+ -Last update: June 1988 / First entry.
+ 
+ [ 1] Hassel J.R., Kimura J.H., Hascall V.C.
+      Annu. Rev. Biochem. 55:539-567(1986).
+ [ 2] Bourdon M.A., Krusius T., Campbell S., Schwarz N.B.
+      Proc. Natl. Acad. Sci. U.S.A. 84:3194-3198(1987).
+ {END}
+ {PDOC00003}
+ {PS00003; SULFATATION}
+ {BEGIN}
+ 
+ *****/
+ 
+ /* Prosite DAT format:
+ //
+ ID   ASN_GLYCOSYLATION; PATTERN.
+ 1234567890
+ AC   PS00001;
+ DT   APR-1990 (CREATED); APR-1990 (DATA UPDATE); APR-1990 (INFO UPDATE).
+ DE   N-glycosylation site.
+ PA   N-{P}-[ST]-{P}.
+ CC   /TAXO-RANGE=??E?V;
+ CC   /SITE=1,carbohydrate;
+ CC   /SKIP-FLAG=TRUE;
+ DO   PDOC00001;
+ //
+ 
+ *****/
+ 
+ boolean prositedoc_separator_function(line)
+ char *line;
+ {
+   if ((strlen(line) > strlen("{END}")) && substrcmp(line, "{END}")){
+      return(true);
+      }
+   else{
+     return(false);
+     }
+ }
+ 
+ 
+ char *prositedoc_def = bio_header1;
+ char *prositedoc_accession= bio_header2;
+ 
+ void prositedoc_header_function(line)
+ char *line;
+ {
+   if ((strlen(line)>2) && (line[0]=='*') && (line[1]==' ') && 
+      (strlen(prositedoc_def) == 0)){
+     strncpy(prositedoc_def, line + 2, MAX_HEADER_LEN);
+     trim_trailing_newline(prositedoc_def);
+     }
+   else if ((strlen(line)>2) && (line[0]=='{') && 
+      (!substrcmp(line, "{END}")) &&
+      (strlen(prositedoc_accession) == 0)){
+ 	char *cp;
+     strncpy(prositedoc_accession, line+1, MAX_HEADER_LEN);
+ 	cp= strchr(prositedoc_accession, '}');
+ 	if (cp!=NULL) *cp=0;  
+     trim_trailing_newline(prositedoc_accession);
+     }
+   
+ }
+ 
+ void prositedoc_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(prositedoc_def) != 0 && strlen(prositedoc_accession) != 0){
+     strncpy(header, prositedoc_accession, MAX_HEADER_LEN);
+     s_strncat(header, " ", MAX_HEADER_LEN, MAX_HEADER_LEN);
+     s_strncat(header, prositedoc_def, MAX_HEADER_LEN, MAX_HEADER_LEN);
+   }
+   else if(strlen(prositedoc_def) != 0){
+     strncpy(header, prositedoc_def, MAX_HEADER_LEN);
+   }
+   else if(strlen(prositedoc_accession) != 0){
+     strncpy(header, prositedoc_accession, MAX_HEADER_LEN);
+   }
+   else{
+     strcpy(header, "Unknown Entry");
+   }
+   prositedoc_def[0] = '\0';
+   prositedoc_accession[0] = '\0';
+ }
+ 
+ 
+ boolean prositedat_separator_function(line)
+ char *line;
+ {
+ /* !! with // as separator, we get // at top of entry which will
+    screw up seqanal software... */
+ /*  if ((strlen(line) > 1) && (0==strncmp(line, "//", 2))){
+      return(true);
+      }  
+ */
+   if ((strlen(line) > prositedat_data_tab) && substrcmp(line, "ID  ")){
+      return(true);
+      }
+   else{
+     return(false);
+     }
+ }
+ 
+ 
+ char *prositedat_def = bio_header1;
+ char *prositedat_accession= bio_header2;
+ 
+ void prositedat_header_function(line)
+ char *line;
+ {
+   int   i;
+ 
+   if ((strlen(line) > prositedat_data_tab) &&
+      substrcmp(line, "DE   ") &&
+      (strlen(prositedat_def) == 0)){
+     strncpy(prositedat_def, line + prositedat_data_tab, MAX_HEADER_LEN);
+     trim_trailing_newline(prositedat_def);
+     }
+ 	
+   else if ((strlen(line) > prositedat_data_tab) &&
+      substrcmp(line, "AC   ") &&
+      (strlen(prositedat_accession) == 0)){
+ 	/* cut extra acc. numbers from this -- we want only 1st */
+ 	char *cp;
+ 	for (cp=line+prositedat_data_tab; *cp==' '; cp++) ;
+     strncpy(prositedat_accession, cp, MAX_HEADER_LEN);
+ 	cp= strchr(prositedat_accession, ' ');
+ 	if (cp!=NULL) *cp=0; /* drop after 1st */
+     trim_trailing_newline(prositedat_accession);
+     }
+    
+   if (strlen(line) > prositedat_data_tab)
+ 	for (i=0; i<prositedat_data_tab; i++) line[i]= ' '; 
+   
+ }
+ 
+ void prositedat_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(prositedat_def) != 0 && strlen(prositedat_accession) != 0){
+     strncpy(header, prositedat_accession, MAX_HEADER_LEN);
+     s_strncat(header, " ", MAX_HEADER_LEN, MAX_HEADER_LEN);
+     s_strncat(header, prositedat_def, MAX_HEADER_LEN, MAX_HEADER_LEN);
+   }
+   else if(strlen(prositedat_def) != 0){
+     strncpy(header, prositedat_def, MAX_HEADER_LEN);
+   }
+   else if(strlen(prositedat_accession) != 0){
+     strncpy(header, prositedat_accession, MAX_HEADER_LEN);
+   }
+   else{
+     strcpy(header, "Unknown Entry");
+   }
+   prositedat_def[0] = '\0';
+   prositedat_accession[0] = '\0';
+ }
+ 
+ /* ==================== 
+  *      Bio Journals        
+  * (modified EMBL format) 
+  * dgg
+  * ================== 
+  */
+ 
+ /******
+ //
+ RA   Casida L.E. Jr.;
+ 123456
+ RT   "Protozoan Response to the Addition of Bacterial Predators and Other
+ RT   Bacteria to Soil.";
+ RL   Appl. Environ. Microbiol. 55:1857-1859(1989).
+ //
+ RA   Caldwell B.A., Ye C., Griffiths R.P., Moyer C.L., Morita R.Y.;
+ RT   "Plasmid Expression and Maintenance during Long-Term Starvation-Survival
+ RT   of Bacteria in Well Water.";
+ RL   Appl. Environ. Microbiol. 55:1860-1864(1989).
+ //
+ *******/
+ 
+ #define biojournal_tab	5
+ 
+ boolean biojournal_separator_function(line)
+ char *line;
+ {
+   if ((strlen(line) > 1) && (0==strncmp(line, "//", 2))){
+      return(true);
+      }  
+ /*  if ((strlen(line) > biojournal_tab) && substrcmp(line, "RA   ")){
+      return(true);
+      }
+ */
+   else{
+     return(false);
+     }
+ }
+ 
+ 
+ char *biojournal_title = bio_header1;
+ char *biojournal_author= bio_header2;
+ 
+ void biojournal_header_function(line)
+ char *line;
+ {
+   int   i;
+ 
+   if ((strlen(line) > biojournal_tab) && substrcmp(line, "RT   ") &&
+      (strlen(biojournal_title) == 0)){
+     strncpy(biojournal_title, line + biojournal_tab, MAX_HEADER_LEN);
+     trim_trailing_newline(biojournal_title);
+     }
+ 	
+   else if ((strlen(line) > biojournal_tab) && substrcmp(line, "RA   ") &&
+      (strlen(biojournal_author) == 0)){
+ 	char *cp;
+     strncpy(biojournal_author, line+biojournal_tab, MAX_HEADER_LEN);
+ 	cp= strchr(biojournal_author, ' ');
+ 	if (cp!=NULL) *cp=0; /* drop after 1st */
+     trim_trailing_newline(biojournal_author);
+     }
+    
+    if (strlen(line) > biojournal_tab)
+ 	for (i=0; i<biojournal_tab; i++) line[i]= ' '; 
+ }
+ 
+ void biojournal_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(biojournal_title) != 0 && strlen(biojournal_author) != 0){
+     strncpy(header, biojournal_author, MAX_HEADER_LEN);
+     s_strncat(header, " ", MAX_HEADER_LEN, MAX_HEADER_LEN);
+     s_strncat(header, biojournal_title, MAX_HEADER_LEN, MAX_HEADER_LEN);
+   }
+   else if(strlen(biojournal_title) != 0){
+     strncpy(header, biojournal_title, MAX_HEADER_LEN);
+   }
+   else if(strlen(biojournal_author) != 0){
+     strncpy(header, biojournal_author, MAX_HEADER_LEN);
+   }
+   else{
+     strcpy(header, "Unknown Entry");
+   }
+   biojournal_title[0] = '\0';
+   biojournal_author[0] = '\0';
+ }
+ 
+ 
+ /* ==========================================
+  *
+  * ===  Drosophila Redbook Customizations  ===
+  *
+  * d.g.gilbert, 18feb92, 
+  * gilbertd@bio.indiana.edu
+  * ==========================================
+  */
+ 
+ /*------ example
+ #Abnormal:  see A
+ #abnormal abdomen:  see a( )
+ #Abnormal abdomen:  see A
+ # abnormal eye:  see mit15
+ #abnormal oocytes:  see abo
+ #abnormal tergites:  see abt
+ #abnormal wings:  see abw
+ #abo:  abnormal oocyte
+  location:  2-44.0 (mapped with respect to J, 2-41).
+  origin:  Naturally occurring allele recovered near Rome,
+    Italy.
+  references:  Sandler, Lindsley, Nicoletti, and Trippa,
+  ...
+ ----*/
+ 
+ 
+ boolean redbook_separator_function(line)
+ char *line;
+ {
+   if(*line=='#'){
+     return(true);
+   }
+   else{
+     return(false);
+   }
+ }
+ 
+ char *redbook_header = bio_header1;
+ 
+ void redbook_header_function(line)
+ char *line;
+ {
+   if(redbook_separator_function(line)){
+     strncpy(redbook_header, line + 1, MAX_HEADER_LEN);
+   }
+ }
+ 
+ void redbook_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(redbook_header) == 0){
+     strncpy(header, "Unknown", MAX_HEADER_LEN);
+   }
+   else{
+     strncpy(header, redbook_header, MAX_HEADER_LEN);
+   }
+   redbook_header[0] = '\0';
+ }
+ 
+ 
+ /* ==========================================
+  *
+  * ===  Drosophila flybase Customizations  ===
+  *
+  * d.g.gilbert, 18feb92, 
+  * gilbertd@bio.indiana.edu
+  * ==========================================
+  */
+ 
+ /*----------------------------------------
+ ::::::::::::::
+ ABAUTOSY.TEXT
+ ::::::::::::::
+ LS(2)P6
+      24E-24F        28A-28D             A
+ LS(2)P11
+      25E-25F        35D                 A
+ ::::::::::::::
+ ABDELETE.TEXT
+ ::::::::::::::
+ Df(1)FM7
+      1A             1B2-1B3             Df   |l(1)1Aa--ac|
+ In(1)y3P$+L$-sc8$+R$-
+      1A             1B2-1B3             Df   |y--ac|
+ ::::::::::::::
+ ABDUPLIC.TEXT
+ ::::::::::::::
+ In(1)sc8$+L$-EN$+R$-
+      1A             1B2-1B3             Dp   |l(1)1Ac--ac|
+ In(1)sc8$+L$-y3P$+R$-
+      1A             1B2-1B3             Dp   |y--ac|
+ ::::::::::::::
+ ABINSERT.TEXT
+ ::::::::::::::
+ TE298
+      1E             []                  I
+ TE276
+      3A1-3A2        []                  I
+ ::::::::::::::
+ ABINVERT.TEXT
+ ::::::::::::::
+ In(1)l-v227
+      1-2            19-20               In
+ In(1)y-G
+      1A             1C3-1C4             In   |y--y|;;
+ ::::::::::::::
+ ABREFS.TEXT
+ ::::::::::::::
+ 3R3L.3R                                 Novitski, Genetics 98:257
+ B$+S$- v$++$- y$++Y$-                   Voelker, Genetics 107:279
+ B$+S$-Ybb$+l$-                          Polembo, Molec.Gen.Genet. 195:35
+ ::::::::::::::
+ ABTRANSL.TEXT
+ ::::::::::::::
+ T(1;2)gl$++$-
+      1A             21C1                T
+ T(1;2)y-v1
+      1A             39                  T    |y--y|;;
+ T(1;2)SP55
+      1A             41                  T
+ ::::::::::::::
+ ABTRANSP.TEXT
+ ::::::::::::::
+ Tp(3;1)pn36
+      1A             61A                 Tp
+ Tp(1;1)Si2
+      1A1-1A8        14D2-14E1           Tp   |r--r|;;
+ Tp(1;1)Si2
+      1A1-1A8        18F                 Tp
+ ::::::::::::::
+ COSMID.TEXT
+ ::::::::::::::
+ 1A\S\T\U      0          0            0                23E12
+ 1A\VS         0          ~50          BH\W             125H10
+ 1B\M\U        0          0            0                88B3
+ ::::::::::::::
+ FUNCTION.TEXT
+ ::::::::::::::
+ 3-hydroxy-3-methylglutaryl-coenzyme-A-reductase               1.1.1.34  HmG-CoAR
+ 6-pyruvoyl-tetrahydropterin-synthase                                     pr
+ 14-3-3-protein                                                           D14-3-3
+ ::::::::::::::
+ LOCI.TEXT
+ ::::::::::::::
+ 3S18;    3S18-element
+               repetitive-element-3S18
+ 4.5SRNA;    4.5SRNA
+           3-[21]     65A
+               RNA-4.5S
+ 5HT-R1;    serotonin-receptor-1
+           3-[102]    100A
+               serotonin-receptor
+               transmembrane-protein
+               G-protein-coupled-receptor
+ 5HT-R2A;    serotonin-receptor
+           2-[87]     56A-56B
+ ::::::::::::::
+ LZSYN.TEXT
+ ::::::::::::::
+  Acp-g1              AcpG
+  Acr96A              Acr96Aa
+  Aldox-1             Aldox1
+ ::::::::::::::
+ MAP.TEXT
+ ::::::::::::::
+ 1-[0]          1A6 ?                            l(1)Ac
+ 1-0.0                                           cc
+ 1-0.0                                           clv-1
+ ::::::::::::::
+ REFS.TEXT
+ ::::::::::::::
+ 4.5SRNA              Steffenson            Genetics 110:s84
+ 5HT-R1               Boschert              12th Europ.Dros.Conference
+ 5HT-R2A              Boschert              12th Europ.Dros.Conference
+ ::::::::::::::
+ SYNONYMS.TEXT
+ ::::::::::::::
+ 1C                                Pk36A
+ 1J                                Pk91C
+ 2sm$+lab$-                        sm
+ 3-2                               Pk45C
+ ::::::::::::::
+ UID.TEXT
+ ::::::::::::::
+ 00001;4.5SRNA
+ 00002;5SRNA
+ 00003;7SLRNA
+ 00004;17.6
+ -----------------------------*/
+ 
+ /*  need something like this for some doc formats.... */
+ 
+ 
+ 
+ boolean flybase_separator_function(line)
+ char *line;
+ {
+   if (isgraph(*line)) {
+     return(true);
+   }
+   else{
+     return(false);
+   }
+ }
+ 
+ char *flybase_header = bio_header1;
+ 
+ void flybase_header_function(line)
+ char *line;
+ {
+   char *c;
+ 	int  i;
+ 	
+   if (flybase_separator_function(line)) {
+ 	  for (c=line, i=0; isgraph(*c) && (i<MAX_HEADER_LEN); )  
+ 			flybase_header[i++]= *c++; 
+ 		flybase_header[i]= '\0';
+     }
+ }
+ 
+ void flybase_finish_header_function(header)
+ char *header;
+ {
+   if(strlen(flybase_header) == 0){
+     strncpy(header, "Unknown", MAX_HEADER_LEN);
+   }
+   else{
+     strncpy(header, flybase_header, MAX_HEADER_LEN);
+   }
+   flybase_header[0] = '\0';
+ }
+ 
+ /* ==========================================
+  * DIN news -- like BIO but "***" separator 
+  * dgg
+  */
+ 
+ boolean din_hit_head = false;
+ char din_header[MAX_HEADER_LEN + 1];
+ 
+ boolean din_separator_function(line)
+ char *line;
+ {
+   if ((strlen(line) >= 3) && substrcmp(line, "***")) {
+     return(true);
+   }
+   else{
+     return(false);
+   }
+ }
+ 
+ 
+ void din_header_function(line)
+ char *line;
+ {
+   if(din_hit_head	/* we just hit a seperator previous to this */
+      && strlen(line) > 3		/* line is valid */
+      && isalnum(*line)			/* and is word */
+      && (!din_separator_function(line)) /* we are not on the separator now */
+      && strlen(din_header) == 0){ /* and we have not saved the headline yet */
+     strcpy(din_header, line);
+     waislog(WLOG_MEDIUM, WLOG_INDEX, "storing line: %s", din_header);
+     din_hit_head = false;
+   }
+ }
+ 
+ void din_finish_header_function(header)
+ char *header;
+ {
+   din_hit_head = true;  /* turn on the flag */
+   if(strlen(din_header) == 0){
+     strcpy(header, "Unknown Title");
+   }
+   else{
+     strcpy(header, din_header);
+   }
+   din_header[0] = '\0';
+ }
+ 
+ 
+ 
+ #endif /* BIO */
+ 
+ 
  /* =================================
   * ===  Groliers Customizations  ===
   * =================================
